#****************************************************************************
#**
#**  File     :  /lua/shield.lua
#**  Author(s):  John Comes, Gordon Duclos
#**
#**  Summary  : Shield lua module
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local oldShield = Shield
Shield = Class(oldShield) {

    InitBuffValues = function(self,spec)
    	self.spec = spec
    	if spec.Owner then self.XPperDamage = spec.Owner:GetBlueprint().Economy.xpValue /spec.ShieldMaxHealth /2 else self.XPperDamage = 0 end
    	#LOG(self.XPperDamage)
   	end,

	OnCreate = function(self,spec)
    	self:InitBuffValues(spec)
    	oldShield.OnCreate(self,spec)
   	end,
   	
   	
   	GetBaseHP = function(self)
    	return self.spec.ShieldMaxHealth or 0
   	end,
   	
   	GetSpec = function(self)
    	return self.spec or nil
   	end,
}

local oldUnitShield = UnitShield
UnitShield = Class(oldUnitShield){

    OnCreate = function(self,spec)
    	Shield.InitBuffValues(self,spec)
        oldUnitShield.OnCreate(self,spec)
   	end,
}

